<template>
  <div class="container">
    <h1 class="title">{{title}}</h1>
    <div class="columns">
      <div class="column is-5">
        <p class="control has-addons">
          <input class="input is-expanded" type="text" placeholder="Procure pelo nome" v-model="Procurar">
          <a class="button is-info" @click.prevent="ProcurarPreprojeto">Procurar</a>
        </p>
      </div>
      <div class="column is-6">
         
      </div>
      <div class="column is-1">
        <a class="button is-info" @click.prevent="newPreprojeto">Inserir Novo</a>
      </div>



    </div>
    <div class="columns">
      <div class="column is-12">
        <table class="table is-narrow is-bordered">
          <thead>
            <th>Nome do Projeto</th>
            <th>Observações</th>
            <th>Orientador</th>
            <th>Status</th>
            <th>Ações</th>
              </thead>
                <tbody>
                 <tr v-for="projeto in Preprojeto">

                    <td>{{projeto.nome}}</td>
                    <td>{{projeto.observacoes}}</td>
                    <td>{{projeto.orientador}}</td>
                    <td>{{projeto.status}}</td>

                    <td class="is-icon">
                        <a href="#" @click.prevent="editprojeto(projeto)">
                        <i class="fa fa-edit"></i>
                        </a>
                        <a href="#" @click.prevent="removeprojeto(projeto)">
                        <i class="fa fa-trash"></i>
                        </a>
                    </td>
                 </tr>
               </tbody>
      </table>
      <Paginacao :total="total" :page="page" :itens-per-page="itensPerPage" @change-page="onChangePage"></Paginacao>
    </div>
  </div>
</div>

<div id="modal_projeto" class="modal" :class="{'is-active':showModal}">
  <div class="modal-background"></div>
  <div class="modal-card">
    <header class="modal-card-head">
      <p class="modal-card-title">Projeto: {{selected.nome}}</p>
      <button class="delete" @click.prevent="showModal=false"></button>
    </header>
    <section class="modal-card-body">

    <div class="columns">
      <div class="column">
        <label class="label">Nome</label>
          <p class="control">
            <input class="input" type="text" placeholder="Nome do Pré-Projeto" v-model="selected.nome">
          </p>
      </div>
      <div class="column">
         <label class="label">Orientador</label>
    <p class="control">
      <input class="input" type="text" placeholder="Orientador" v-model="selected.orientador">
    </p>
      </div>
      </div>

      <label class="label">Observação</label>
      <p class="control">
        <textarea class="textarea" placeholder="Observaçãoes do Pré-Projeto" v-model="selected.observacoes"></textarea>
      </p>
      
      <label class="label">Status</label>
          <p class="control">
      <input class="input" type="text" placeholder="Status" v-model="selected.status">
    </p>


    </section>
    <footer class="modal-card-foot">
      <a class="button is-primary" @click.prevent="saveprojeto">Salvar</a>
      <a class="button" @click.prevent="showModal=false">Cancelar</a>
    </footer>
  </div>
</div>
</template>

<script>
  import Paginacao from './Paginacao.vue'
  

  export default {
    data () {
      return {
        isLoading: false,
        title: 'Cadastro de Pré Projetos',
        Procurar: '',
        Preprojeto: [],
        page: 1,
        total: 0,
        selected: {},
        itensPerPage: 10,
        showModal:false
      }
    },
    components: {
      Paginacao
    },
    methods: {
      onChangePage(page){
        this.page = page
        this.loadPreprojeto()
      },
      showLoading(){
        this.isLoading=true;
      },
      hideLoading(){
        this.isLoading=false;
      },
      loadPreprojeto(){

        let t = this
        this.showLoading()

        let start = (this.page * this.itensPerPage) - (this.itensPerPage)
        let end = this.page * this.itensPerPage
        let qString = "";

        if (this.Procurar){
          qString = `&q=${this.Procurar}`
        }

        this.$http.get(`/Preprojeto?_start=${start}&_end=${end}${qString}`).then(
         response=>{
           t.Preprojeto = response.json()
           t.total = response.headers['X-Total-Count']
         },
         error=>{
           console.log(error)
         }).finally(function () {
          t.hideLoading();
        })

       },
       ProcurarPreprojeto(){
        this.loadPreprojeto()
       },
       newPreprojeto(){
        this.selected={}
        this.showModal = true;
       },
       editprojeto(projeto){
        this.selected=projeto
        this.showModal = true;
       },
       removeprojeto(projeto){
        let self = this;
        swal({  title: "Você tem certeza?",
                 text: `Deseja apagar "${projeto.nome}"`,   
                 type: "warning",   
                 showCancelButton: true,   
                 confirmButtonColor: "#DD6B55",   
                 cancelButtonText: "Cancelar",
                 confirmButtonText: "Sim, pode apagar!", 
                 showLoaderOnConfirm: true,  
                 closeOnConfirm: false }, function(){   
                  
                  self.$http.delete(`/Preprojeto/${projeto.id}`).then(
                    result=>{
                      swal("Pré-Projeto removido!")
                      self.loadPreprojeto()
                    })
        });

       },
       saveprojeto(){
        if (this.selected.id!=null){  //EDIT
          this.$http.put(`/Preprojeto/${this.selected.id}`,this.selected).then(
            response=>{
              this.$set('selected',{})
              this.$set('showModal',false)
            },
            error=>{
              console.error(error)
            }
            ).finally(
              this.loadPreprojeto()
            )
          }
          else
          { //NEW
            this.$http.post(`/Preprojeto`,this.selected).then(
            response=>{
              this.$set('selected',{})
              this.$set('showModal',false)
            },
            error=>{
              console.error(error)
            }
            ).finally(
              this.loadPreprojeto()
            )
          }
       }
     },
     created(){
      this.loadPreprojeto();
    },
  }
</script>
<style>
  .fixo{float: right; margin-right: 10px; margin-top: 0px; z-index: 1000;}
</style>